<?php
class DB {
	private static $_instance;

	private $db, $id, $table, $result;

	public static function instance() {
		if(!isset(self::$_instance)) {
			self::$_instance = new DB();
		}

		return self::$_instance;
	}

	public function __construct() {
		$this->db = new mysqli("localhost", "root", "root", "website"); // Would usually come from a config
	}

	public function query($sql) {
		if(!$this->result = $this->db->query($sql)) {
			throw new Exception("Something went wrong.");
		}

		return $this;
	}

	public function result() {
		$result = [];

		while($row = $this->result->fetch_object()) {
			$result[] = $row;
		}

		return $result;
	}

	public function count() {
		if(isset($this->result)) {
			return $this->result->num_rows;
		}
	}

	public function table($table) {
		$this->table = $this->db->real_escape_string($table);
		return $this;
	}

	public function get($id = null) {
		if(isset($this->table) && $id) {
			$this->id = (int)$id;
		} else {
			$this->query("SELECT * FROM {$this->table}");
		}

		return $this;
	}

	public function insert($data = array()) {
		if(isset($this->table)) {

			foreach($data as $index => $value) {
				$data[$index] = $this->db->real_escape_string($value);
			}

			$fields = implode(", ", array_keys($data));
			$values = "'" . implode("', '", $data) . "'";

			$this->query("INSERT INTO {$this->table} ({$fields}) VALUES ({$values})");
		}
	}

	public function update($data = array()) {
		if(isset($this->table, $this->id)) {

			$set = "";
			$x = 0;

			foreach($data as $field => $value) {
				$set .= "{$this->db->real_escape_string($field)} = '{$this->db->real_escape_string($value)}'";
				
				if($x != count($data) - 1) {
					$set .= ", ";
				}

				$x++;
			}

			$this->query("UPDATE {$this->table} SET {$set} WHERE id = {$this->id}");

		}
	}

	public function delete() {
		if(isset($this->table, $this->id)) {
			$this->query("DELETE FROM {$this->table} WHERE id = {$this->id}");
		}
	}

}